# Maintainer: Arnoud Willemsen <mail@lynthium.com>

pkgname='clevo-xsm-wmi'
pkgver='1.2'
_pkgtag="v${pkgver}"
pkgrel=1
pkgdesc='A reverse engineering driver for the Clevo laptop models backlight keyboard.'
arch=('i686' 'x86_64')
license=('GPL')
url='https://gitlab.com/LiZhenhuan1019/clevo-xsm-wmi'
source=("clevo-xsm-wmi-${pkgver}.src.tar.gz::https://gitlab.com/LiZhenhuan1019/clevo-xsm-wmi/-/archive/v${pkgver}/clevo-xsm-wmi-v${pkgver}.tar.gz")
options=(!emptydirs)
makedepends=('linux-headers')
install='clevo-xsm-wmi.install'

build() {
    cd "${srcdir}/clevo-xsm-wmi-${_pkgtag}/module"
    make
}

package() {
    cd "${srcdir}/clevo-xsm-wmi-${_pkgtag}/module"

    _PACKAGES=`pacman -Qsq linux`
    _KERNELS=`pacman -Ql $_packages | grep /modules.alias.bin | sed 's/.*\/lib\/modules\/\(.*\)\/modules.alias.bin/\1/g'`

    # Find all extramodules directories
    _EXTRAMODULES=`find /usr/lib/modules -name version | sed 's|\/usr\/lib\/modules\/||; s|\/version||'`

    # Loop through all detected kernels
    for _kernver in $_KERNELS; do
        # Loop through all detected extramodules directories
        for _moduledirs in $_EXTRAMODULES; do
            # Check which extramodules directory corresponds with the built module
            if [ `cat "/usr/lib/modules/${_moduledirs}/version"` = $_kernver ]; then
                mkdir -p "${pkgdir}/usr/lib/modules/${_moduledirs}/"
                install -m644 clevo-xsm-wmi.ko "${pkgdir}/usr/lib/modules/${_moduledirs}/"
                xz "${pkgdir}/usr/lib/modules/${_moduledirs}/clevo-xsm-wmi.ko"
            fi
        done
    done

    install -D -m644 /usr/share/licenses/common/GPL2/license.txt "${pkgdir}/usr/share/licenses/${pkgname}/LICENSE"

    mkdir -p "${pkgdir}/etc/modules-load.d"
    echo "clevo-xsm-wmi" > "${pkgdir}/etc/modules-load.d/clevo-xsm-wmi.conf"
}
sha256sums=('edb776faecb364ffb79dfd2550bda03ff19dc893bf19a1460324f328a15b2bf1')
